/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package edu.virginia.cs.escjava;

import java.util.Vector;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.part.ViewPart;

/**
 * @author LCUSER
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class ResultView extends ViewPart implements SelectionListener, AuditListener {

	private Tree treeRoot;
	
	public void refreshView() {
		treeRoot.removeAll();
		
		IProject[] projectsArray = ResourcesPlugin.getWorkspace().getRoot().getProjects();
		for(int i = 0; i < projectsArray.length; i++)
		{
			IProject project = projectsArray[i];
			if(project.isOpen())
			{
				TreeItem ti = new TreeItem(treeRoot, SWT.NONE);
				ti.setText(project.getName());
				try {
					IMarker[] markers = project.findMarkers(
							EscjavaPlugin.ESCJAVA_MARKER_ID,
							true,
							IResource.DEPTH_INFINITE);
					for(int j = 0; j < markers.length; j++)
					{
						IMarker im = markers[j];
						String text = (String) im.getAttribute(IMarker.MESSAGE);
						TreeItem treeitem = new TreeItem(ti, SWT.NONE);
						treeitem.setText(text);
						int numberOfLines = im.getAttribute("messagelength", 0);
						for(int k = 0; k < numberOfLines; k++)
						{
							TreeItem item = new TreeItem(treeitem, SWT.NONE);
							item.setText((String) im.getAttribute("message" + k));
						}
					}
				} catch (CoreException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				
			}
		}
	}
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createPartControl(Composite parent) {
		// TODO Auto-generated method stub
		GridLayout layout = new GridLayout();
		// layout.type = SWT.VERTICAL;
		// layout.wrap = true;
		// layout.pack = true;
		// layout.justify = true;
		layout.numColumns = 1;
		parent.setLayout(layout);
		Button refreshButton = new Button(parent, SWT.PUSH);
		refreshButton.setText("Refresh view");
		refreshButton.addSelectionListener(this);
		GridData buttonGridData = new GridData();
		buttonGridData.verticalAlignment = GridData.END;
		buttonGridData.horizontalAlignment = GridData.CENTER;
		refreshButton.setLayoutData(buttonGridData);
		
		// refreshButton.setLayoutData(new RowData(50,20));
		treeRoot = new Tree(parent, SWT.PUSH);
		GridData gridData = new GridData();

		gridData.verticalAlignment = GridData.FILL;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		treeRoot.setLayoutData(gridData);

		refreshView();
//		parent.pack();
	}
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPart#setFocus()
	 */
	public void setFocus() {
		// TODO Auto-generated method stub

	}

	public void fileStarted(AuditEvent arg0) {
	}

	public void fileFinished(AuditEvent arg0) {
	}
	
	public void addError(AuditEvent event) {
		if (event.getSeverityLevel() != SeverityLevel.IGNORE) {
//			createMarker(event.getMessage(), adaptLevel(event.getSeverityLevel()), event.getLine(), event.getText());
			// System.out.println("creating marker: " + event.getMessage() + "asdf " + event.getText());
		}
		TreeItem ti = new TreeItem(treeRoot, SWT.NONE);
		ti.setText(event.getMessage());
		Vector details = event.getDetailedMessage();
		for(int i = 0; i < details.size(); i++)
		{
			TreeItem newItem = new TreeItem(ti, SWT.NONE);
			newItem.setText((String) details.get(i));
		}
	}
	
	/* (non-Javadoc)
	 * @see edu.virginia.cs.escjava.AuditListener#auditStarted(edu.virginia.cs.escjava.AuditEvent)
	 */
	public void auditStarted(AuditEvent aEvt) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.virginia.cs.escjava.AuditListener#auditFinished(edu.virginia.cs.escjava.AuditEvent)
	 */
	public void auditFinished(AuditEvent aEvt) {
		// TODO Auto-generated method stub
		
	}
	
	public void addException(AuditEvent arg0, Throwable arg1) {
	}
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public void widgetSelected(SelectionEvent e) {
		// TODO Auto-generated method stub
		refreshView();
	}
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public void widgetDefaultSelected(SelectionEvent e) {
		// TODO Auto-generated method stub
		
	}
}
